import matplotlib.artist as martist
from typing import Any

GRIDLINE_INTERPOLATION_STEPS: int

class Tick(martist.Artist):
    axes: Any
    tick1line: Any
    tick2line: Any
    gridline: Any
    label1: Any
    label2: Any
    def __init__(self, axes, loc, *, size: Any | None = ..., width: Any | None = ..., color: Any | None = ..., tickdir: Any | None = ..., pad: Any | None = ..., labelsize: Any | None = ..., labelcolor: Any | None = ..., zorder: Any | None = ..., gridOn: Any | None = ..., tick1On: bool = ..., tick2On: bool = ..., label1On: bool = ..., label2On: bool = ..., major: bool = ..., labelrotation: int = ..., grid_color: Any | None = ..., grid_linestyle: Any | None = ..., grid_linewidth: Any | None = ..., grid_alpha: Any | None = ..., **kw) -> None: ...
    @property
    def label(self): ...
    stale: bool
    def apply_tickdir(self, tickdir) -> None: ...
    def get_tickdir(self): ...
    def get_tick_padding(self): ...
    def get_children(self): ...
    def set_clip_path(self, clippath, transform: Any | None = ...) -> None: ...
    def get_pad_pixels(self): ...
    def contains(self, mouseevent): ...
    def set_pad(self, val) -> None: ...
    def get_pad(self): ...
    def get_loc(self): ...
    def draw(self, renderer) -> None: ...
    def set_label1(self, s) -> None: ...
    set_label: Any
    def set_label2(self, s) -> None: ...
    def set_url(self, url) -> None: ...
    def get_view_interval(self) -> None: ...
    def update_position(self, loc) -> None: ...

class XTick(Tick):
    __name__: str
    def __init__(self, *args, **kwargs) -> None: ...
    stale: bool
    def update_position(self, loc) -> None: ...
    def get_view_interval(self): ...

class YTick(Tick):
    __name__: str
    def __init__(self, *args, **kwargs) -> None: ...
    stale: bool
    def update_position(self, loc) -> None: ...
    def get_view_interval(self): ...

class Ticker:
    def __init__(self) -> None: ...
    @property
    def locator(self): ...
    @locator.setter
    def locator(self, locator) -> None: ...
    @property
    def formatter(self): ...
    @formatter.setter
    def formatter(self, formatter) -> None: ...

class _LazyTickList:
    def __init__(self, major) -> None: ...
    def __get__(self, instance, cls): ...

class Axis(martist.Artist):
    OFFSETTEXTPAD: int
    isDefault_label: bool
    axes: Any
    major: Any
    minor: Any
    callbacks: Any
    label: Any
    offsetText: Any
    labelpad: Any
    pickradius: Any
    def __init__(self, axes, pickradius: int = ...) -> None: ...
    @property
    def isDefault_majloc(self): ...
    @isDefault_majloc.setter
    def isDefault_majloc(self, value) -> None: ...
    @property
    def isDefault_majfmt(self): ...
    @isDefault_majfmt.setter
    def isDefault_majfmt(self, value) -> None: ...
    @property
    def isDefault_minloc(self): ...
    @isDefault_minloc.setter
    def isDefault_minloc(self, value) -> None: ...
    @property
    def isDefault_minfmt(self): ...
    @isDefault_minfmt.setter
    def isDefault_minfmt(self, value) -> None: ...
    majorTicks: Any
    minorTicks: Any
    def get_remove_overlapping_locs(self): ...
    def set_remove_overlapping_locs(self, val) -> None: ...
    remove_overlapping_locs: Any
    stale: bool
    def set_label_coords(self, x, y, transform: Any | None = ...) -> None: ...
    def get_transform(self): ...
    def get_scale(self): ...
    def limit_range_for_scale(self, vmin, vmax): ...
    def get_children(self): ...
    converter: Any
    units: Any
    def clear(self) -> None: ...
    def cla(self): ...
    def reset_ticks(self) -> None: ...
    def set_tick_params(self, which: str = ..., reset: bool = ..., **kw) -> None: ...
    def set_clip_path(self, clippath, transform: Any | None = ...) -> None: ...
    def get_view_interval(self) -> None: ...
    def set_view_interval(self, vmin, vmax, ignore: bool = ...) -> None: ...
    def get_data_interval(self) -> None: ...
    def set_data_interval(self, vmin, vmax, ignore: bool = ...) -> None: ...
    def get_inverted(self): ...
    def set_inverted(self, inverted) -> None: ...
    def set_default_intervals(self) -> None: ...
    def get_ticklabel_extents(self, renderer): ...
    def get_tightbbox(self, renderer, *, for_layout_only: bool = ...): ...
    def get_tick_padding(self): ...
    def draw(self, renderer, *args, **kwargs) -> None: ...
    def get_gridlines(self): ...
    def get_label(self): ...
    def get_offset_text(self): ...
    def get_pickradius(self): ...
    def get_majorticklabels(self): ...
    def get_minorticklabels(self): ...
    def get_ticklabels(self, minor: bool = ..., which: Any | None = ...): ...
    def get_majorticklines(self): ...
    def get_minorticklines(self): ...
    def get_ticklines(self, minor: bool = ...): ...
    def get_majorticklocs(self): ...
    def get_minorticklocs(self): ...
    def get_ticklocs(self, *, minor: bool = ...): ...
    def get_ticks_direction(self, minor: bool = ...): ...
    def get_label_text(self): ...
    def get_major_locator(self): ...
    def get_minor_locator(self): ...
    def get_major_formatter(self): ...
    def get_minor_formatter(self): ...
    def get_major_ticks(self, numticks: Any | None = ...): ...
    def get_minor_ticks(self, numticks: Any | None = ...): ...
    def grid(self, visible: Any | None = ..., which: str = ..., **kwargs) -> None: ...
    def update_units(self, data): ...
    def have_units(self): ...
    def convert_units(self, x): ...
    def set_units(self, u) -> None: ...
    def get_units(self): ...
    def set_label_text(self, label, fontdict: Any | None = ..., **kwargs): ...
    def set_major_formatter(self, formatter) -> None: ...
    def set_minor_formatter(self, formatter) -> None: ...
    def set_major_locator(self, locator) -> None: ...
    def set_minor_locator(self, locator) -> None: ...
    def set_pickradius(self, pickradius) -> None: ...
    def set_ticklabels(self, ticklabels, *, minor: bool = ..., **kwargs): ...
    def set_ticks(self, ticks, labels: Any | None = ..., *, minor: bool = ..., **kwargs): ...
    def axis_date(self, tz: Any | None = ...) -> None: ...
    def get_tick_space(self) -> None: ...
    def get_label_position(self): ...
    def set_label_position(self, position) -> None: ...
    def get_minpos(self) -> None: ...

class XAxis(Axis):
    __name__: str
    axis_name: str
    label_position: str
    offset_text_position: str
    def __init__(self, *args, **kwargs) -> None: ...
    def contains(self, mouseevent): ...
    stale: bool
    def set_label_position(self, position) -> None: ...
    def get_text_heights(self, renderer): ...
    def set_ticks_position(self, position) -> None: ...
    def tick_top(self) -> None: ...
    def tick_bottom(self) -> None: ...
    def get_ticks_position(self): ...
    get_view_interval: Any
    set_view_interval: Any
    get_data_interval: Any
    set_data_interval: Any
    def get_minpos(self): ...
    def set_inverted(self, inverted) -> None: ...
    def set_default_intervals(self) -> None: ...
    def get_tick_space(self): ...

class YAxis(Axis):
    __name__: str
    axis_name: str
    label_position: str
    offset_text_position: str
    def __init__(self, *args, **kwargs) -> None: ...
    def contains(self, mouseevent): ...
    stale: bool
    def set_label_position(self, position) -> None: ...
    def set_offset_position(self, position) -> None: ...
    def get_text_widths(self, renderer): ...
    def set_ticks_position(self, position) -> None: ...
    def tick_right(self) -> None: ...
    def tick_left(self) -> None: ...
    def get_ticks_position(self): ...
    get_view_interval: Any
    set_view_interval: Any
    get_data_interval: Any
    set_data_interval: Any
    def get_minpos(self): ...
    def set_inverted(self, inverted) -> None: ...
    def set_default_intervals(self) -> None: ...
    def get_tick_space(self): ...
