from typing import Any

class InstallableLib:
    name: Any
    build_info: Any
    target_dir: Any
    def __init__(self, name, build_info, target_dir) -> None: ...

def get_num_build_jobs(): ...
def quote_args(args): ...
def allpath(name): ...
def njoin(*path): ...
def get_mathlibs(path: Any | None = ...): ...
def minrelpath(path): ...
def gpaths(paths, local_path: str = ..., include_non_existing: bool = ...): ...
def terminal_has_colors(): ...
def red_text(s): ...
def green_text(s): ...
def yellow_text(s): ...
def cyan_text(s): ...
def blue_text(s): ...
def cyg2win32(path): ...
def mingw32(): ...
def is_string(s): ...
def all_strings(lst): ...
def is_sequence(seq): ...
def as_list(seq): ...
def get_language(sources): ...
def has_f_sources(sources): ...
def has_cxx_sources(sources): ...
def filter_sources(sources): ...
def get_dependencies(sources): ...
def is_local_src_dir(directory): ...
def get_ext_source_files(ext): ...
def get_script_files(scripts): ...
def get_lib_source_files(lib): ...
def get_data_files(data): ...
def dot_join(*args): ...
def get_frame(level: int = ...): ...

class Configuration:
    numpy_include_dirs: Any
    name: Any
    version: Any
    local_path: Any
    top_path: Any
    package_path: Any
    path_in_package: Any
    list_keys: Any
    dict_keys: Any
    extra_keys: Any
    options: Any
    setup_name: Any
    def __init__(self, package_name: Any | None = ..., parent_name: Any | None = ..., top_path: Any | None = ..., package_path: Any | None = ..., caller_level: int = ..., setup_name: str = ..., **attrs) -> None: ...
    def todict(self): ...
    def info(self, message) -> None: ...
    def warn(self, message) -> None: ...
    def set_options(self, **options) -> None: ...
    def get_distribution(self): ...
    def get_subpackage(self, subpackage_name, subpackage_path: Any | None = ..., parent_name: Any | None = ..., caller_level: int = ...): ...
    def add_subpackage(self, subpackage_name, subpackage_path: Any | None = ..., standalone: bool = ...) -> None: ...
    def add_data_dir(self, data_path): ...
    def add_data_files(self, *files) -> None: ...
    def add_define_macros(self, macros) -> None: ...
    def add_include_dirs(self, *paths) -> None: ...
    def add_headers(self, *files) -> None: ...
    def paths(self, *paths, **kws): ...
    def add_extension(self, name, sources, **kw): ...
    def add_library(self, name, sources, **build_info) -> None: ...
    def add_installed_library(self, name, sources, install_dir, build_info: Any | None = ...) -> None: ...
    def add_npy_pkg_config(self, template, install_dir, subst_dict: Any | None = ...) -> None: ...
    def add_scripts(self, *files) -> None: ...
    def dict_append(self, **dict) -> None: ...
    def get_config_cmd(self): ...
    def get_build_temp_dir(self): ...
    def have_f77c(self): ...
    def have_f90c(self): ...
    def append_to(self, extlib) -> None: ...
    def get_version(self, version_file: Any | None = ..., version_variable: Any | None = ...): ...
    def make_svn_version_py(self, delete: bool = ...): ...
    def make_hg_version_py(self, delete: bool = ...): ...
    def make_config_py(self, name: str = ...) -> None: ...
    def get_info(self, *names): ...

def get_cmd(cmdname, _cache=...): ...
def get_numpy_include_dirs(): ...
def get_pkg_info(pkgname, dirs: Any | None = ...): ...
def get_info(pkgname, dirs: Any | None = ...): ...
def default_config_dict(name: Any | None = ..., parent_name: Any | None = ..., local_path: Any | None = ...): ...
def dict_append(d, **kws) -> None: ...
def appendpath(prefix, path): ...
def generate_config_py(target): ...
def get_build_architecture(): ...
