from sklearn import tree as tree
from sklearn.datasets import load_diabetes as load_diabetes
from sklearn.dummy import DummyRegressor as DummyRegressor
from sklearn.exceptions import ConvergenceWarning as ConvergenceWarning
from sklearn.experimental import enable_iterative_imputer as enable_iterative_imputer
from sklearn.impute import IterativeImputer as IterativeImputer, MissingIndicator as MissingIndicator, SimpleImputer as SimpleImputer
from sklearn.linear_model import ARDRegression as ARDRegression, BayesianRidge as BayesianRidge, RidgeCV as RidgeCV
from sklearn.model_selection import GridSearchCV as GridSearchCV
from sklearn.pipeline import Pipeline as Pipeline, make_union as make_union
from sklearn.utils._testing import assert_allclose as assert_allclose, assert_allclose_dense_sparse as assert_allclose_dense_sparse, assert_array_almost_equal as assert_array_almost_equal, assert_array_equal as assert_array_equal

def test_imputation_shape(strategy) -> None: ...
def test_imputation_error_invalid_strategy(strategy) -> None: ...
def test_imputation_deletion_warning(strategy) -> None: ...
def test_imputation_error_sparse_0(strategy) -> None: ...
def safe_median(arr, *args, **kwargs): ...
def safe_mean(arr, *args, **kwargs): ...
def test_imputation_mean_median(): ...
def test_imputation_median_special_cases() -> None: ...
def test_imputation_mean_median_error_invalid_type(strategy, dtype) -> None: ...
def test_imputation_mean_median_error_invalid_type_list_pandas(strategy, type) -> None: ...
def test_imputation_const_mostf_error_invalid_types(strategy, dtype) -> None: ...
def test_imputation_most_frequent() -> None: ...
def test_imputation_most_frequent_objects(marker) -> None: ...
def test_imputation_most_frequent_pandas(dtype) -> None: ...
def test_imputation_constant_error_invalid_type(X_data, missing_value) -> None: ...
def test_imputation_constant_integer() -> None: ...
def test_imputation_constant_float(array_constructor) -> None: ...
def test_imputation_constant_object(marker) -> None: ...
def test_imputation_constant_pandas(dtype) -> None: ...
def test_iterative_imputer_one_feature(X) -> None: ...
def test_imputation_pipeline_grid_search() -> None: ...
def test_imputation_copy() -> None: ...
def test_iterative_imputer_zero_iters() -> None: ...
def test_iterative_imputer_verbose() -> None: ...
def test_iterative_imputer_all_missing() -> None: ...
def test_iterative_imputer_imputation_order(imputation_order) -> None: ...
def test_iterative_imputer_estimators(estimator) -> None: ...
def test_iterative_imputer_clip() -> None: ...
def test_iterative_imputer_clip_truncnorm() -> None: ...
def test_iterative_imputer_truncated_normal_posterior() -> None: ...
def test_iterative_imputer_missing_at_transform(strategy) -> None: ...
def test_iterative_imputer_transform_stochasticity() -> None: ...
def test_iterative_imputer_no_missing() -> None: ...
def test_iterative_imputer_rank_one() -> None: ...
def test_iterative_imputer_transform_recovery(rank) -> None: ...
def test_iterative_imputer_additive_matrix() -> None: ...
def test_iterative_imputer_error_param(max_iter, tol, error_type, warning) -> None: ...
def test_iterative_imputer_early_stopping() -> None: ...
def test_iterative_imputer_catch_warning() -> None: ...
def test_iterative_imputer_min_max_array_like(min_value, max_value, correct_output) -> None: ...
def test_iterative_imputer_catch_min_max_error(min_value, max_value, err_msg) -> None: ...
def test_iterative_imputer_min_max_array_like_imputation(min_max_1, min_max_2) -> None: ...
def test_iterative_imputer_skip_non_missing(skip_complete) -> None: ...
def test_iterative_imputer_dont_set_random_state(rs_imputer, rs_estimator): ...
def test_missing_indicator_error(X_fit, X_trans, params, msg_err) -> None: ...
def test_missing_indicator_new(missing_values, arr_type, dtype, param_features, n_features, features_indices) -> None: ...
def test_missing_indicator_raise_on_sparse_with_missing_0(arr_type) -> None: ...
def test_missing_indicator_sparse_param(arr_type, missing_values, param_sparse) -> None: ...
def test_missing_indicator_string() -> None: ...
def test_missing_indicator_with_imputer(X, missing_values, X_trans_exp) -> None: ...
def test_inconsistent_dtype_X_missing_values(imputer_constructor, imputer_missing_values, missing_value, err_msg) -> None: ...
def test_missing_indicator_no_missing() -> None: ...
def test_missing_indicator_sparse_no_explicit_zeros() -> None: ...
def test_imputer_without_indicator(imputer_constructor) -> None: ...
def test_simple_imputation_add_indicator_sparse_matrix(arr_type) -> None: ...
def test_simple_imputation_string_list(strategy, expected) -> None: ...
def test_imputation_order(order, idx_order) -> None: ...
def test_simple_imputation_inverse_transform(missing_value) -> None: ...
def test_simple_imputation_inverse_transform_exceptions(missing_value) -> None: ...
def test_most_frequent(expected, array, dtype, extra_value, n_repeat) -> None: ...
