from sklearn.base import BaseEstimator as BaseEstimator, ClassifierMixin as ClassifierMixin
from sklearn.compose import make_column_transformer as make_column_transformer
from sklearn.datasets import load_breast_cancer as load_breast_cancer, make_classification as make_classification
from sklearn.exceptions import NotFittedError as NotFittedError
from sklearn.linear_model import LogisticRegression as LogisticRegression
from sklearn.metrics import average_precision_score as average_precision_score, plot_precision_recall_curve as plot_precision_recall_curve, precision_recall_curve as precision_recall_curve
from sklearn.model_selection import train_test_split as train_test_split
from sklearn.pipeline import make_pipeline as make_pipeline
from sklearn.preprocessing import StandardScaler as StandardScaler
from sklearn.tree import DecisionTreeClassifier as DecisionTreeClassifier, DecisionTreeRegressor as DecisionTreeRegressor
from sklearn.utils import shuffle as shuffle
from typing import Any

pytestmark: Any

def test_errors(pyplot) -> None: ...
def test_error_bad_response(pyplot, response_method, msg): ...
def test_plot_precision_recall(pyplot, response_method, with_sample_weight) -> None: ...
def test_precision_recall_curve_pipeline(pyplot, clf) -> None: ...
def test_precision_recall_curve_string_labels(pyplot) -> None: ...
def test_plot_precision_recall_curve_estimator_name_multiple_calls(pyplot) -> None: ...
def test_plot_precision_recall_pos_label(pyplot, response_method) -> None: ...
