from tensorflow.core.protobuf import cluster_pb2 as cluster_pb2, device_filters_pb2 as device_filters_pb2, tensorflow_server_pb2 as tensorflow_server_pb2
from tensorflow.python.framework import errors as errors
from tensorflow.python.util import compat as compat, deprecation as deprecation
from tensorflow.python.util.tf_export import tf_export as tf_export
from typing import Any

class Server:
    def __init__(self, server_or_cluster_def, job_name: Any | None = ..., task_index: Any | None = ..., protocol: Any | None = ..., config: Any | None = ..., start: bool = ...) -> None: ...
    def __del__(self) -> None: ...
    def start(self) -> None: ...
    def join(self) -> None: ...
    @property
    def server_def(self): ...
    @property
    def target(self): ...
    @staticmethod
    def create_local_server(config: Any | None = ..., start: bool = ...): ...

class ClusterSpec:
    def __init__(self, cluster) -> None: ...
    def __bool__(self): ...
    __nonzero__: Any
    def __eq__(self, other): ...
    def __ne__(self, other): ...
    def as_dict(self): ...
    def as_cluster_def(self): ...
    @property
    def jobs(self): ...
    def num_tasks(self, job_name): ...
    def task_indices(self, job_name): ...
    def task_address(self, job_name, task_index): ...
    def job_tasks(self, job_name): ...

class ClusterDeviceFilters:
    def __init__(self) -> None: ...
    def set_device_filters(self, job_name, task_index, device_filters) -> None: ...
